DECLARE @stringId AS int;
DECLARE @cultureId AS int;

-- Get culture ID
SET @cultureID = (SELECT UICultureID FROM [CMS_UICulture] WHERE UICultureCode='en-US');

-- Delete existing resource string and translations
DELETE FROM [CMS_ResourceTranslation] WHERE TranslationStringID IN (SELECT StringID FROM [CMS_ResourceString] WHERE StringKey='ObjectTasks.__MEDIALIBRARY__')
DELETE FROM [CMS_ResourceString] WHERE StringKey='ObjectTasks.__MEDIALIBRARY__'
	
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('ObjectTasks.__MEDIALIBRARY__'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Media libraries')

-- Delete existing resource string and translations
DELETE FROM [CMS_ResourceTranslation] WHERE TranslationStringID IN (SELECT StringID FROM [CMS_ResourceString] WHERE StringKey='ObjectType.Media_File')
DELETE FROM [CMS_ResourceString] WHERE StringKey='ObjectType.Media_File'
           
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('ObjectType.Media_File'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Media file')          
GO 


ALTER PROCEDURE [Proc_Community_Group_RemoveDependencies]	
	@GroupID int
AS
BEGIN	
	SET NOCOUNT ON;

    -- Get AvatarID from current group
    DECLARE @AvatarID int;
    SELECT @AvatarID = GroupAvatarID FROM [Community_Group] WHERE GroupID=@GroupID
    IF (@AvatarID > 0)
    BEGIN
      DECLARE @AvatarIsCustom bit;
      SELECT @AvatarIsCustom = AvatarIsCustom FROM [CMS_Avatar]
      IF (@AvatarIsCustom=1)
      BEGIN
	    UPDATE [Community_Group] SET GroupAvatarID=NULL WHERE GroupAvatarID=@AvatarID;
        DELETE FROM [CMS_Avatar] WHERE AvatarID=@AvatarID
      END
    END

	-- Members
	DELETE FROM [Community_GroupMember] WHERE MemberGroupID = @GroupID

	-- Group role permission
	DELETE FROM [Community_GroupRolePermission] WHERE GroupID = @GroupID

	-- Forums
	UPDATE [Forums_ForumPost] SET PostParentID=NULL WHERE PostForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionPostID IN (
			SELECT PostID FROM Forums_ForumPost WHERE (PostForumID  IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));
	DELETE FROM [Forums_UserFavorites] WHERE PostID IN (
			SELECT PostID FROM [Forums_ForumPost] WHERE ( PostForumId IN (  
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));
	DELETE FROM [Forums_UserFavorites] WHERE ForumID IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_Attachment] WHERE AttachmentPostID IN (
			SELECT PostID FROM [Forums_ForumPost] WHERE ( PostForumId IN (  
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));	
	DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_Forum] WHERE ForumGroupId IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		);
	DELETE FROM Forums_ForumGroup WHERE GroupGroupID = @GroupID;

	-- Polls
	DELETE FROM [Polls_PollRoles] WHERE PollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_PollSite] WHERE PollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_PollAnswer] WHERE AnswerPollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_Poll] WHERE PollGroupID = @GroupID;

	-- Roles
	DELETE FROM [CMS_UserRole] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);
	DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_ACLItem] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

    DELETE FROM [FORUMS_ForumRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [Polls_PollRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [Board_Role] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_Role] WHERE RoleGroupID = @GroupID;

	-- Group message boards
    DELETE FROM Board_Message WHERE MessageBoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Moderator WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Role WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Subscription WHERE SubscriptionBoardID IN (SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID);
	DELETE FROM Board_Board WHERE BoardGroupID = @GroupID;

	-- Group invitation
	DELETE FROM Community_Invitation WHERE InvitationGroupID = @GroupID;

	-- Remove refrences to the tree node
	UPDATE CMS_TREE SET NodeGroupID = NULL WHERE NodeGroupID = @GroupID;

END
GO


DECLARE @classId int;
SET @classId = (SELECT TOP 1 ClassID FROM CMS_Class WHERE ClassName = N'CMS.DocumentAlias')
IF @classId <>0 BEGIN

UPDATE CMS_Query SET QueryText = 'SELECT ##COLUMNS## FROM CMS_DocumentAlias INNER JOIN CMS_Tree ON CMS_DocumentAlias.AliasNodeID = CMS_Tree.NodeID WHERE (@WildcardRule=AliasURLPath OR @WildcardRule LIKE CMS_DocumentAlias.AliasWildcardRule) AND CMS_Tree.NodeSiteID = @SiteID ORDER BY AliasPriority' WHERE ClassID=@classId AND QueryName='selectbywildcardrule'

END
GO

-- Remove staging tasks for document aliases
DELETE FROM Staging_SyncLog WHERE (SyncLogTaskID IN (SELECT TaskID FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')))
DELETE FROM Staging_Synchronization WHERE (SynchronizationTaskID IN (SELECT TaskID FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')))
DELETE FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')
GO


-- Update CMS.DocumentAlias.selectbywildcardrule query due to underscore characters
DECLARE @classId int;
SET @classId = (SELECT TOP 1 ClassID FROM CMS_Class WHERE ClassName = N'CMS.DocumentAlias')
IF @classId <>0 BEGIN

UPDATE CMS_Query SET QueryText = 'SELECT ##COLUMNS## FROM CMS_DocumentAlias INNER JOIN CMS_Tree ON CMS_DocumentAlias.AliasNodeID = CMS_Tree.NodeID WHERE (@UrlPath=AliasURLPath OR @WildcardRule LIKE CMS_DocumentAlias.AliasWildcardRule) AND CMS_Tree.NodeSiteID = @SiteID ORDER BY AliasPriority' WHERE ClassID=@classId AND QueryName='selectbywildcardrule'

END 
GO

-- Update View_CMS_Tree_Joined_Versions for all COM_SKU columns
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER VIEW [dbo].[View_CMS_Tree_Joined_Versions]
AS
SELECT     CASE WHEN ((DocumentCheckedOutVersionHistoryID IS NULL AND DocumentPublishedVersionHistoryID IS NULL) OR
                      (DocumentCheckedOutVersionHistoryID IS NOT NULL AND DocumentPublishedVersionHistoryID IS NOT NULL)) AND (DocumentPublishFrom IS NULL OR
                      (DocumentPublishFrom IS NOT NULL AND DocumentPublishFrom <= getdate())) AND (DocumentPublishTo IS NULL OR
                      (DocumentPublishTo IS NOT NULL AND DocumentPublishTo >= getdate())) AND ((StepName <> 'archived') OR
                      (StepName IS NULL)) THEN 1 ELSE 0 END AS Published, dbo.CMS_Site.SiteName, dbo.CMS_Class.ClassName, dbo.CMS_Class.ClassDisplayName, 
                      dbo.CMS_Tree.NodeID, dbo.CMS_Tree.NodeAliasPath, dbo.CMS_Tree.NodeName, dbo.CMS_Tree.NodeAlias, dbo.CMS_Tree.NodeClassID, 
                      dbo.CMS_Tree.NodeParentID, dbo.CMS_Tree.NodeLevel, dbo.CMS_Tree.NodeACLID, dbo.CMS_Tree.NodeSiteID, dbo.CMS_Tree.NodeGUID, 
                      dbo.CMS_Tree.NodeOrder, dbo.CMS_Tree.IsSecuredNode, dbo.CMS_Tree.NodeCacheMinutes, dbo.CMS_Tree.NodeSKUID, 
                      dbo.CMS_Tree.NodeDocType, dbo.CMS_Tree.NodeHeadTags, dbo.CMS_Tree.NodeBodyElementAttributes, dbo.CMS_Tree.NodeInheritPageLevels, 
                      dbo.CMS_Tree.NodeChildNodesCount, dbo.CMS_Tree.RequiresSSL, dbo.CMS_Tree.NodeLinkedNodeID, dbo.CMS_Tree.NodeOwner, 
                      dbo.CMS_Tree.NodeCustomData, dbo.CMS_Tree.NodeGroupID, dbo.CMS_Document.DocumentID, dbo.CMS_Document.DocumentName, 
                      dbo.CMS_Document.DocumentNamePath, dbo.CMS_Document.DocumentModifiedWhen, dbo.CMS_Document.DocumentModifiedByUserID, 
                      dbo.CMS_Document.DocumentForeignKeyValue, dbo.CMS_Document.DocumentCreatedByUserID, dbo.CMS_Document.DocumentCreatedWhen, 
                      dbo.CMS_Document.DocumentCheckedOutByUserID, dbo.CMS_Document.DocumentCheckedOutWhen, 
                      dbo.CMS_Document.DocumentCheckedOutVersionHistoryID, dbo.CMS_Document.DocumentPublishedVersionHistoryID, 
                      dbo.CMS_Document.DocumentWorkflowStepID, dbo.CMS_Document.DocumentPublishFrom, dbo.CMS_Document.DocumentPublishTo, 
                      dbo.CMS_Document.DocumentUrlPath, dbo.CMS_Document.DocumentCulture, dbo.CMS_Document.DocumentNodeID, 
                      dbo.CMS_Document.DocumentPageTitle, dbo.CMS_Document.DocumentPageKeyWords, dbo.CMS_Document.DocumentPageDescription, 
                      dbo.CMS_Document.DocumentShowInSiteMap, dbo.CMS_Document.DocumentMenuItemHideInNavigation, dbo.CMS_Document.DocumentMenuCaption,
                       dbo.CMS_Document.DocumentMenuStyle, dbo.CMS_Document.DocumentMenuItemImage, dbo.CMS_Document.DocumentMenuItemLeftImage, 
                      dbo.CMS_Document.DocumentMenuItemRightImage, dbo.CMS_Document.DocumentPageTemplateID, dbo.CMS_Document.DocumentMenuJavascript, 
                      dbo.CMS_Document.DocumentMenuRedirectUrl, dbo.CMS_Document.DocumentUseNamePathForUrlPath, dbo.CMS_Document.DocumentStylesheetID, 
                      dbo.CMS_Document.DocumentContent, dbo.CMS_Document.DocumentMenuClass, dbo.CMS_Document.DocumentMenuStyleOver, 
                      dbo.CMS_Document.DocumentMenuClassOver, dbo.CMS_Document.DocumentMenuItemImageOver, 
                      dbo.CMS_Document.DocumentMenuItemLeftImageOver, dbo.CMS_Document.DocumentMenuItemRightImageOver, 
                      dbo.CMS_Document.DocumentMenuStyleHighlighted, dbo.CMS_Document.DocumentMenuClassHighlighted, 
                      dbo.CMS_Document.DocumentMenuItemImageHighlighted, dbo.CMS_Document.DocumentMenuItemLeftImageHighlighted, 
                      dbo.CMS_Document.DocumentMenuItemRightImageHighlighted, dbo.CMS_Document.DocumentMenuItemInactive, 
                      dbo.CMS_Document.DocumentCustomData, dbo.CMS_Document.DocumentExtensions, dbo.CMS_Document.DocumentCampaign, 
                      dbo.CMS_Document.DocumentTags, dbo.CMS_Document.DocumentTagGroupID, dbo.CMS_Document.DocumentWildcardRule, 
                      dbo.CMS_Document.DocumentWebParts, dbo.CMS_Document.DocumentRatingValue, dbo.CMS_Document.DocumentRatings, 
                      dbo.CMS_Document.DocumentPriority, dbo.CMS_Document.DocumentType, COM_SKU.*, dbo.CMS_VersionHistory.NodeXML, dbo.CMS_WorkflowStep.StepName, dbo.CMS_VersionHistory.VersionNumber, 
                      dbo.CMS_Document.DocumentLastPublished
FROM         dbo.View_Node_Document INNER JOIN
                      dbo.CMS_Document ON dbo.View_Node_Document.DocumentID = dbo.CMS_Document.DocumentID INNER JOIN
                      dbo.CMS_Tree ON dbo.CMS_Tree.NodeID = dbo.View_Node_Document.NodeID INNER JOIN
                      dbo.CMS_Site ON dbo.View_Node_Document.NodeSiteID = dbo.CMS_Site.SiteID INNER JOIN
                      dbo.CMS_Class ON dbo.View_Node_Document.NodeClassID = dbo.CMS_Class.ClassID LEFT OUTER JOIN
                      dbo.CMS_VersionHistory ON 
                      dbo.CMS_Document.DocumentCheckedOutVersionHistoryID = dbo.CMS_VersionHistory.VersionHistoryID LEFT OUTER JOIN
                      dbo.CMS_WorkflowStep ON dbo.CMS_Document.DocumentWorkflowStepID = dbo.CMS_WorkflowStep.StepID LEFT OUTER JOIN
                      dbo.View_COM_SKU AS COM_SKU ON dbo.CMS_Tree.NodeSKUID = COM_SKU.SKUID
GO